--LIBS
LootTracker = LibStub("AceAddon-3.0"):NewAddon("Loot Tracker", "AceConsole-3.0", "AceEvent-3.0")

--FUNCTIONS
function removeUTF8(str)
	--REPLACE UTF8 BULLSHIT
	str = str:gsub("á","a")
	str = str:gsub("à","a")
	str = str:gsub("â","a")
	str = str:gsub("ä","a")
	str = str:gsub("å","a")
	str = str:gsub("ã","a")
	str = str:gsub("æ","a")
	str = str:gsub("ç","c")
	str = str:gsub("é","e")
	str = str:gsub("è","e")
	str = str:gsub("ê","e")
	str = str:gsub("ë","e")
	str = str:gsub("í","i")
	str = str:gsub("ì","i")
	str = str:gsub("î","i")
	str = str:gsub("ï","i")
	str = str:gsub("ñ","n")
	str = str:gsub("ó","o")
	str = str:gsub("ò","o")
	str = str:gsub("ô","o")
	str = str:gsub("ö","o")
	str = str:gsub("õ","o")
	str = str:gsub("ø","o")
	str = str:gsub("œ","oe")
	str = str:gsub("š","s")
	str = str:gsub("ú","u")
	str = str:gsub("ù","u")
	str = str:gsub("û","u")
	str = str:gsub("ü","u")
	str = str:gsub("ý","y")
	str = str:gsub("ÿ","y")
	str = str:gsub("ž","z")
	--END REPLACE UTF8 BULLSHIT
	
	return str
end

function in_array(arr, str)
	for k in pairs(arr) do
		if k == str then return true end
	end
	return false
end

function split(inputstr, sep)
        if sep == nil then
                sep = "%s"
        end
        local t={}
        for str in string.gmatch(inputstr, "([^"..sep.."]+)") do
                table.insert(t, str)
        end
        return t
end

function searchArrInStr(str, arr)
	str = string.upper(str)
	
	for k in ipairs(arr) do
		arr[k] = string.upper(removeUTF8(arr[k]))
		
		if string.match(string.upper(str), string.upper(arr[k])) then
			return arr[k]
		end
	end
	return false
end

function getInfoFromStrLoot(str)
	arg2 = str

	local patternPlayerName = "^%a*"
	local playerName = string.match(arg2, patternPlayerName) -- foo
	
	local patternLootName = "%[([%a% %d-]*)%]" -- foo - 123
	local lootName = string.match(arg2, patternLootName)
	
	local patternNumberLoot = "x(%d*)%." -- digit
	local numberLoot = string.match(arg2, patternNumberLoot)
	if numberLoot == nil then numberLoot = 1 end

	return playerName, lootName, numberLoot
end

function stringify(arr)
	local str = ""
	for k in pairs(arr) do
		for kk in pairs(arr[k]) do
			if str == "" then 
				str = k.." -> "..kk.." = "..arr[k][kk]
			else 
				str = str.."\r\n"..k.." -> "..kk.." = "..arr[k][kk] 
			end
		end
	end
	return str
end
--FUNCTIONS

--INIT VAR
local defaults = { 
    profile = {
		active = false,
		terms = "",
		result = {},
        qDebug = false,
		alertScreen = false,
		alertChat = false,
    }, 
} 

local options = {
    name = "Loot Tracker",
    handler = LootTracker,
    type = 'group',
    args = {
		active = {
			order = 1,
			type = "toggle",
			name = "Active",
			get = "IsActive",
			set = "ToggleActive",
		},
		labelTermsList = {
			order = 2,
			type = "description",
			name = "Search terms list (separated by comma ',') :",
		},
		termsList = {
			order = 3,
			type = "input",
			multiline = true,
			width = "full",
			name = "",
			desc = "",
			--usage = "<Your message here>",
			get = "GetTerms",
			set = "SetTerms",
		},
		labelResult = {
			order = 4,
			type = "description",
			name = "Search result list :",
		},
		searchResultList = {
			order = 5,
			type = "input",
			multiline = true,
			width = "full",
			name = "",
			get = "GetResult",
		},
		buttonResultReset = {
			order = 6,
			type = "execute",
			name = "Result reset",
			func = "resetResultList"
		},
		alertScreen = {
			order = 7,
			type = "toggle",
			name = "Alert on screen",
			get = "IsAlertScreen",
			set = "ToggleAlertScreen",
		},
		alertChat = {
			order = 8,
			type = "toggle",
			name = "Alert in chat",
			get = "IsAlertChat",
			set = "ToggleAlertChat",
		},
		qDebug = {
			order = 9,
			type = "toggle",
			name = "Debug",
			get = "IsDebug",
			set = "ToggleDebug",
		},
    },
}
--INIT VAR

function LootTracker:OnInitialize()
    -- Called when the addon is loaded
	self.db = LibStub("AceDB-3.0"):New("LootTrackerDB", defaults, true)
	LibStub("AceConfig-3.0"):RegisterOptionsTable("LootTracker", options, {"loottracker", "lt"})
	self.optionsFrame = LibStub ("AceConfigDialog-3.0"): AddToBlizOptions ("LootTracker", "LootTracker") 
	self:RegisterChatCommand("lt", "ChatCommand") 
    self:RegisterChatCommand("loottracker", "ChatCommand") 
end

function LootTracker:OnEnable()
    -- Called when the addon is enabled
	self:RegisterEvent("CHAT_MSG_LOOT")
end

function LootTracker:OnDisable()
    -- Called when the addon is disabled
end

function LootTracker:CHAT_MSG_LOOT(arg1,arg2)
	if self.db.profile.active == false then return end
	if self.db.profile.qDebug then self:Print(arg1) end

	local playerName, lootName, numberLoot = getInfoFromStrLoot(removeUTF8(arg2))
	local arrTerms = split(self.db.profile.terms, ",")
	if self.db.profile.qDebug then self:Print("lootName : " .. lootName) end

	if searchArrInStr(lootName, arrTerms) then
		if in_array(self.db.profile.result, playerName) then
			if in_array(self.db.profile.result[playerName], lootName) then
				if self.db.profile.qDebug then self:Print("update playerName : "..playerName) end
				local total = numberLoot + self.db.profile.result[playerName][lootName]
				if self.db.profile.qDebug then self:Print("update lootName : " .. self.db.profile.result[playerName][lootName] .. " + " .. numberLoot .. " = " .. total) end
				self.db.profile.result[playerName][lootName] = total
			else
				if self.db.profile.qDebug then self:Print("update numberLoot : " .. numberLoot) end
				self.db.profile.result[playerName][lootName] = numberLoot
			end
		else
			if self.db.profile.qDebug then self:Print("insert playerName : " .. playerName) end
			self.db.profile.result[playerName] = {}
			if self.db.profile.qDebug then self:Print("insert lootName : " .. lootName) end
			if self.db.profile.qDebug then self:Print("insert numberLoot : " .. numberLoot) end
			self.db.profile.result[playerName][lootName] = numberLoot
		end
		
		if self.db.profile.alertChat then
			self:Print(playerName.." -> "..lootName.." + "..numberLoot)
		end

		if self.db.profile.alertScreen then
			UIErrorsFrame:AddMessage(playerName.." -> "..lootName.." + "..numberLoot, 1.0, 1.0, 1.0, 5.0)
		end
	else
		if self.db.profile.qDebug then self:Print("LOOT DON'T MATCH WITH TERMS SAVED") end
	end
end


function LootTracker:ChatCommand(input)
    if not input or input:trim() == "" then
        InterfaceOptionsFrame_OpenToCategory(self.optionsFrame)
    else
        LibStub("AceConfigCmd-3.0"):HandleCommand("lt", "LootTracker", input)
    end
end

function LootTracker:IsActive(info)
    return self.db.profile.active
end

function LootTracker:ToggleActive(info, value)
    self.db.profile.active = value
end

function LootTracker:IsDebug(info)
    return self.db.profile.qDebug
end

function LootTracker:ToggleDebug(info, value)
    self.db.profile.qDebug = value
end

function LootTracker:IsAlertScreen(info)
    return self.db.profile.alertScreen
end

function LootTracker:ToggleAlertScreen(info, value)
    self.db.profile.alertScreen = value
end

function LootTracker:IsAlertChat(info)
    return self.db.profile.alertChat
end

function LootTracker:ToggleAlertChat(info, value)
    self.db.profile.alertChat = value
end

function LootTracker:GetTerms(info)
	if self.db.profile.qDebug then self:Print("GetTerms "..self.db.profile.terms) end
	return self.db.profile.terms
end

function LootTracker:SetTerms(info, newValue)
	if self.db.profile.qDebug then self:Print("SetTerms "..newValue) end
	self.db.profile.terms = newValue
end

function LootTracker:resetResultList(info)
	self.db.profile.result = {}
end

function LootTracker:GetResult(info)
	if self.db.profile.qDebug then self:Print("GetResult ") end
	return stringify(self.db.profile.result)
end